#include "stdafx.h"
#include "Test_DynamicCreation_Button.h"
#include "Test_DynamicCreation_ButtonDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV Դϴ.

protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()

CTest_DynamicCreation_ButtonDlg::CTest_DynamicCreation_ButtonDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTest_DynamicCreation_ButtonDlg::IDD, pParent)
	, m_nBtnNumber(20)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTest_DynamicCreation_ButtonDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, m_nBtnNumber);
}

BEGIN_MESSAGE_MAP(CTest_DynamicCreation_ButtonDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, &CTest_DynamicCreation_ButtonDlg::OnBnClickedButton1)
	ON_WM_DRAWITEM()
END_MESSAGE_MAP()

BOOL CTest_DynamicCreation_ButtonDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// ū  մϴ.
	SetIcon(m_hIcon, FALSE);		//   մϴ.

	return TRUE;  // Ŀ Ʈѿ   TRUE ȯմϴ.
}

void CTest_DynamicCreation_ButtonDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CTest_DynamicCreation_ButtonDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // ׸⸦  ̽ ؽƮ

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CTest_DynamicCreation_ButtonDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

BOOL CTest_DynamicCreation_ButtonDlg::OnCommand(WPARAM wParam, LPARAM lParam)
{
	if(wParam >= 2000 && wParam < 2000 + m_arrButton.GetSize())
	{
		for(int i = 0; i < m_arrButton.GetSize(); i++)
		{
			if(2000 + i == wParam)
			{
				CString strTmp;
				strTmp.Format("%d ư", i + 1);
				MessageBox(strTmp);
			}
		}
	}

	return CDialog::OnCommand(wParam, lParam);
} 

void CTest_DynamicCreation_ButtonDlg::OnBnClickedButton1()
{
	UpdateData(TRUE);

	if(m_nBtnNumber > 20)
	{
		MessageBox(_T("20̸ ϼ"));
		return;
	}

	if(m_arrButton.GetSize() > 0)
		ClearButton();
	
	for(int i = 0; i <= m_nBtnNumber; i++)
	{
		int left = 10 + (i * 30) + i * 2;
		int top = 40;
		int right = 10 + (i * 30) + (i * 2) + 30;
		int bottom = 65;

		CButton* createButton = new CButton;
		createButton->Create(NULL, BS_PUSHBUTTON | WS_VISIBLE | WS_CHILD | BS_OWNERDRAW, CRect(left, top, right, bottom), this, 2000 + i);
		addButton(createButton);
	}

	Invalidate(TRUE);
}

void CTest_DynamicCreation_ButtonDlg::addButton(CButton* createButton)
{
	m_arrButton.Add(createButton);
}

void CTest_DynamicCreation_ButtonDlg::ClearButton()
{
	for(int i = 0; i < m_arrButton.GetSize(); i++)
	{
		CButton* deleteButton = m_arrButton.GetAt(i);
		delete deleteButton;
		deleteButton = NULL;
	}

	m_arrButton.RemoveAll();	m_arrButton.FreeExtra();
}
void CTest_DynamicCreation_ButtonDlg::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	UINT uStyle = DFCS_BUTTONPUSH;

	ASSERT(lpDrawItemStruct->CtlType == ODT_BUTTON);

	if (lpDrawItemStruct->itemState & ODS_SELECTED)
		uStyle |= DFCS_PUSHED;

	::DrawFrameControl(lpDrawItemStruct->hDC, &lpDrawItemStruct->rcItem, DFC_BUTTON, uStyle);

	CDC dc;
	dc.Attach(lpDrawItemStruct->hDC);

	RECT rect;
	rect = lpDrawItemStruct->rcItem;

	if(nIDCtl >= 2000 && nIDCtl < nIDCtl + m_arrButton.GetSize())
	{
		for(int i = 0; i < m_arrButton.GetSize(); i++)
		{
			if(nIDCtl == 2000 + i)
			{
				dc.FillSolidRect(&rect, RGB(static_cast<unsigned int>(rand() % 254), static_cast<unsigned int>(rand() % 254), static_cast<unsigned int>(rand() % 254)));
				break;
			}
		}
	}

	//CDialog::OnDrawItem(nIDCtl, lpDrawItemStruct);
}
